From 9f20fbaec8b7df501cbe99d6ab9f311d07d141c4 Mon Sep 17 00:00:00 2001
From: Sumit Garg <sumit.garg@nxp.com>
Date: Wed, 4 May 2016 13:28:37 -0400
Subject: [PATCH 3/4] Correct exception check while handling fast calls

Exception check is corrected while handling fast calls. Instead of
comparing exception level after fast call handling with THREAD_EXCP_ALL,
compare it with exception level prior to fast call handling.

Signed-off-by: Sumit Garg <sumit.garg@nxp.com>
---
 core/arch/arm/kernel/thread.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/core/arch/arm/kernel/thread.c b/core/arch/arm/kernel/thread.c
index 633db89..06b8760 100644
--- a/core/arch/arm/kernel/thread.c
+++ b/core/arch/arm/kernel/thread.c
@@ -524,10 +524,11 @@ static void thread_resume_from_rpc(struct thread_smc_args *args)
 
 void thread_handle_fast_smc(struct thread_smc_args *args)
 {
+	uint32_t exp_status = thread_get_exceptions();
 	thread_check_canaries();
 	thread_fast_smc_handler_ptr(args);
 	/* Fast handlers must not unmask any exceptions */
-	assert(thread_get_exceptions() == THREAD_EXCP_ALL);
+	assert(thread_get_exceptions() == exp_status);
 }
 
 void thread_handle_std_smc(struct thread_smc_args *args)
-- 
1.8.1.4

